## teem 1.12.0~20160122

=== CMakeLists.txt ===
#
# Teem: Tools to process and visualize scientific data and images
# Copyright (C) 2013, 2012, 2011, 2010, 2009  University of Chicago
# Copyright (C) 2008, 2007, 2006, 2005  Gordon Kindlmann
# Copyright (C) 2004, 2003, 2002, 2001, 2000, 1999, 1998  University of Utah
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# (LGPL) as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The terms of redistributing and/or modifying this software also
# include exceptions to the LGPL that facilitate static linking.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

# This is the root Teem CMakeLists file
cmake_minimum_required(VERSION 2.8)

# Cmake shouldn't define WIN32 when compiling
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

# As of CMake 2.6 Policies were introduced in order to provide a mechanism for
# adding backwards compatibility one feature at a time.

# Library paths (/path/to/libmy.so not translated to -L/path/to -lmy)
cmake_policy(SET CMP0003 NEW)
if(POLICY CMP0033)
# The ``export_library_dependencies()`` command should not be called.
# The functionality has been superseded by export() and install(EXPORT) commands
  cmake_policy(SET CMP0033 NEW)
endif()
if(POLICY CMP0054)
#Only interpret ``if()`` arguments as variables or keywords when unquoted.
  cmake_policy(SET CMP0054 OLD)
endif()

project(Teem)

#-----------------------------------------------------------------------------
# Teem version number.  Must reflect the values in teem/src/air/air.h
set(Teem_VERSION_MAJOR "1")
set(Teem_VERSION_MINOR "12")
set(Teem_VERSION_PATCH "0")

# Version string should not include patch level.  The major.minor is
# enough to distinguish available features of the toolkit.
set(Teem_VERSION_STRING "${Teem_VERSION_MAJOR}.${Teem_VERSION_MINOR}.${Teem_VERSION_PATCH}")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/CMake")

# We need ansi c-flags, especially on HP
set(CMAKE_C_FLAGS "${CMAKE_ANSI_CFLAGS} ${CMAKE_C_FLAGS}")
set(CMAKE_REQUIRED_FLAGS ${CMAKE_ANSI_CFLAGS})

#-----------------------------------------------------------------------------
# Test for some required system information.
include (CMakeBackwardCompatibilityC)

#-----------------------------------------------------------------------------
# Output directories.

foreach(type LIBRARY RUNTIME ARCHIVE)
  # Make sure the directory exists
  if(DEFINED CMAKE_${type}_OUTPUT_DIRECTORY
     AND NOT EXISTS ${CMAKE_${type}_OUTPUT_DIRECTORY})
    message(FATAL_ERROR "CMAKE_${type}_OUTPUT_DIRECTORY is set to a non-existing directory [${CMAKE_${type}_OUTPUT_DIRECTORY}]")
  endif()
  if(NOT DEFINED CMAKE_${type}_OUTPUT_DIRECTORY)
    set(CMAKE_${type}_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
  endif()
endforeach()

if(BUILD_SHARED_LIBS)
  set(__LIBRARY_OUTPUT_PATH__ "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
else()
  set(__LIBRARY_OUTPUT_PATH__ "${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}")
endif()
set(__RUNTIME_OUTPUT_PATH_ "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")

#output directory for installing all include files.")

file(MAKE_DIRECTORY ${Teem_BINARY_DIR}/include)
file(MAKE_DIRECTORY ${Teem_BINARY_DIR}/include/teem)

#-----------------------------------------------------------------------------
# Find platform-specific differences in the handling of IEEE floating point
# special values.

include(${Teem_SOURCE_DIR}/CMake/TestQnanhibit.cmake)
TEST_QNANHIBIT(QNANHIBIT_VALUE ${Teem_SOURCE_DIR}/CMake)
if(QNANHIBIT_VALUE)
  set(QNANHIBIT 1 CACHE INTERNAL "The 22nd bit of 32-bit floating-point quiet NaN.")
else()
  set(QNANHIBIT 0 CACHE INTERNAL "The 22nd bit of 32-bit floating-point quiet NaN.")
endif()


#-----------------------------------------------------------------------------
# test if AIR_EXISTS macro fails
try_run(AIR_EXISTS_MACRO_FAILS AIR_EXISTS_MACRO_COMPILE
  ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/CMake/testAirExists.cxx
)

#-----------------------------------------------------------------------------
# Teem build configuration options.
option(BUILD_SHARED_LIBS "Build Teem with shared libraries." OFF)
set(Teem_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})
if(NOT Teem_BUILD_SHARED_LIBS)
  add_definitions(-DTEEM_STATIC)
endif()

option(Teem_ZLIB "Build Teem with support for gzip compression." ON)
option(Teem_PNG "Build Teem with support for PNG images." ON)
option(Teem_VTK_MANGLE "Build Teem using the mangled libraries from VTK for ZLIB and PNG." OFF)
set(Teem_VTK_ZLIB_MANGLE_IPATH "" CACHE PATH "Location of vtk_zlib_mangle.h")
set(Teem_VTK_TOOLKITS_IPATH "" CACHE PATH "Location of VTK Build directory for ZLIB and PNG includes.")

# Can't build PNG without ZLIB, so force it on.
if(Teem_PNG AND NOT Teem_ZLIB)
  set(Teem_ZLIB ON)
endif()

if(Teem_VTK_MANGLE)
  add_definitions(-DTEEM_VTK_MANGLE=1)
  include_directories( ${Teem_VTK_TOOLKITS_IPATH} )
  include_directories( ${Teem_VTK_ZLIB_MANGLE_IPATH} )
endif()


set(Teem_ZLIB_LIB "")
set(Teem_PNG_LIB "")
if(Teem_ZLIB)
  # Find ZLIB
  find_package(ZLIB)
  if(ZLIB_FOUND)
    add_definitions(-DTEEM_ZLIB)
    set(Teem_ZLIB_LIB ${ZLIB_LIBRARIES})
    set(Teem_ZLIB_IPATH ${ZLIB_INCLUDE_DIR})
  else()
    # We need to set this as a cache variable, so that it will show up as
    # being turned off in the cache.
    message("warning: Turning off Teem_ZLIB, because it wasn't found.")
    set(Teem_ZLIB OFF CACHE BOOL "Build Teem with support for gzip compression." FORCE)
  endif()

  if(Teem_PNG)
    find_package(PNG)
    if(PNG_FOUND)
      add_definitions(-DTEEM_PNG ${PNG_DEFINITIONS})
      set(Teem_PNG_LIB ${PNG_LIBRARIES})
      set(Teem_PNG_IPATH ${PNG_INCLUDE_DIR})
    else()
      # We need to set this as a cache variable, so that it will show up as
      # being turned off in the cache.
      message("warning: Turning off Teem_PNG, because it wasn't found.")
      set(Teem_PNG OFF CACHE BOOL "Build Teem with support for PNG images." FORCE)
    endif()
  endif()
endif()

# Try and locate BZIP2 stuff
option(Teem_BZIP2 "Build Teem with support for bzip compression." ON)
set(Teem_BZIP2_LIB "")

if(Teem_BZIP2)
  find_package(BZ2)

  if(BZ2_FOUND)
    add_definitions(-DTEEM_BZIP2)
    set(Teem_BZIP2_LIB ${BZ2_LIBRARIES})
    set(Teem_BZIP2_IPATH ${BZ2_INCLUDE_DIR})
  else()
    # We need to set this as a cache variable, so that it will show up as
    # being turned off in the cache.
    message("warning: Turning off Teem_BZIP2, because it wasn't found.")
    set(Teem_BZIP2 OFF CACHE BOOL "Build Teem with support for bzip compression." FORCE)
  endif()
endif()

# Look for threading libraries
option(Teem_PTHREAD "Build Teem with pthread library support." ON)
if(Teem_PTHREAD)
  include(FindThreads)
  if(CMAKE_USE_PTHREADS_INIT)
    add_definitions(-DTEEM_PTHREAD)
  else()
    # We need to set this as a cache variable, so that it will show up as
    # being turned off in the cache.
    message("warning: Turning off Teem_PTHREAD, because it wasn't found.")
    set(Teem_PTHREAD OFF CACHE BOOL "Build Teem with pthread library support." FORCE)
    set(Teem_PTHREAD OFF)
  endif()
endif()

# Look for "levmar" library <http://www.ics.forth.gr/~lourakis/levmar/>
option(Teem_LEVMAR "Build Teem with levmar library support." OFF)
set(Teem_LEVMAR_LIB "")
if(Teem_LEVMAR)
  find_package(LEVMAR)

  if(LEVMAR_FOUND)
    add_definitions(-DTEEM_LEVMAR)
    set(Teem_LEVMAR_LIB ${LEVMAR_LIBRARIES})
    set(Teem_LEVMAR_IPATH ${LEVMAR_INCLUDE_DIR})
  else()
    # We need to set this as a cache variable, so that it will show up as
    # being turned off in the cache.
    message("warning: Turning off Teem_LEVMAR, because it wasn't found.")
    set(Teem_LEVMAR OFF CACHE BOOL "Build Teem with levmar library support." FORCE)
  endif()
endif()

# Look for fftw <http://www.fftw.org/>
option(Teem_FFTW3 "Build Teem with fftw library support." OFF)
set(Teem_FFTW3_LIB "")

if(Teem_FFTW3)
  find_package(FFTW3)

  if(FFTW3_FOUND)
    add_definitions(-DTEEM_FFTW3)
    set(Teem_FFTW3_LIB ${FFTW3_LIBRARIES})
    set(Teem_FFTW3_IPATH ${FFTW3_INCLUDE_DIR})
  else()
    # We need to set this as a cache variable, so that it will show up as
    # being turned off in the cache.
    message("warning: Turning off Teem_FFTW3, because it wasn't found.")
    set(Teem_FFTW3 OFF CACHE BOOL "Build Teem with fftw library support." FORCE)
  endif()
endif()

#-----------------------------------------------------------------------------

if(${CMAKE_GENERATOR} MATCHES "Visual Studio")
  # For Visual Studio we don't care about warnings about deprecated sprintf and
  # the like.
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
endif()

#Teem Defines
#The QNANHIBIT variable is configured by the root level CMakeLists.txt
if(QNANHIBIT)
  add_definitions(-DTEEM_QNANHIBIT=1)
else()
  add_definitions(-DTEEM_QNANHIBIT=0)
endif()

#DirectIO is the fast way to do multi-gigabyte I/O and currently only available
#for SGI platforms.  Use of DirectIO is enabled manually for now.
#option(USE_DIRECTIO "Use DirectIO for Nrrd file IO.  Only valid on SGI systems." 0)
#mark_as_advanced(USE_DIRECTIO)
#if(USE_DIRECTIO)
#  add_definitions(-DTEEM_DIO=1)
#else()
add_definitions(-DTEEM_DIO=0)
#endif()

set(BUILD_EXPERIMENTAL_LIBS OFF CACHE BOOL "Build Teem's experimental libraries")
set(BUILD_EXPERIMENTAL_APPS OFF CACHE BOOL "Build Teem's non-essential command-line tools")

# If its a Dashboard build; turn ON both
# BUILD_EXPERIMENTAL_APPS and BUILD_EXPERIMENTAL_LIBS
# (h/t David Cole)
if(NOT "$ENV{DASHBOARD_TEST_FROM_CTEST}" STREQUAL "")
  # it is a dashboard build
  set(BUILD_EXPERIMENTAL_APPS ON)
  set(BUILD_EXPERIMENTAL_LIBS ON)
endif()

# (TEEM_LIB_LIST)
set(Teem_LIBRARIES air hest biff nrrd ell unrrdu moss gage dye limn echo hoover seek ten pull mite meet)
if(BUILD_EXPERIMENTAL_LIBS)
  # This list of the "experimental" libraries must be kept in sync with:
  # * definition of Teem_HEADER_FILES (below)
  # * teem/src/meet/meet.h
  # * teem/src/meet/enumsall.c
  # re-setting list so libraries appear in expected order
  set(Teem_LIBRARIES air hest biff nrrd ell unrrdu alan moss tijk gage dye bane limn echo hoover seek ten elf pull coil push mite meet)
  add_definitions(-DTEEM_BUILD_EXPERIMENTAL_LIBS)
endif()

if(BUILD_EXPERIMENTAL_APPS)
  add_definitions(-DTEEM_BUILD_EXPERIMENTAL_APPS)
endif()

set(Teem_HEADER_FILES
  air/air.h
  hest/hest.h
  biff/biff.h
  nrrd/nrrd.h   nrrd/nrrdDefines.h   nrrd/nrrdMacros.h  nrrd/nrrdEnums.h
  ell/ell.h     ell/ellMacros.h
  unrrdu/unrrdu.h
  moss/moss.h
  gage/gage.h
  dye/dye.h
  limn/limn.h
  echo/echo.h
  hoover/hoover.h
  seek/seek.h
  ten/ten.h     ten/tenMacros.h
  pull/pull.h
  mite/mite.h
  meet/meet.h
  )
if(BUILD_EXPERIMENTAL_LIBS)
  set(Teem_HEADER_FILES ${Teem_HEADER_FILES}
    alan/alan.h
    tijk/tijk.h
    bane/bane.h
    elf/elf.h
    coil/coil.h
    push/push.h
    )
endif()
set(Teem_INSTALLED_HEADER_FILES)
foreach(header_file ${Teem_HEADER_FILES})
  # When debugging, uncomment this line
  #message(STATUS "Copy header file: ${header_file}")
  get_filename_component(file_no_path "${header_file}" NAME)
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/src/${header_file}"
    "${CMAKE_CURRENT_BINARY_DIR}/include/teem/${file_no_path}" COPYONLY IMMEDIATE)
  set(Teem_INSTALLED_HEADER_FILES
    ${Teem_INSTALLED_HEADER_FILES}
    "${CMAKE_CURRENT_BINARY_DIR}/include/teem/${file_no_path}")
endforeach()

#---
# header that defines AIR_EXISTS_MACRO_FAILS
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/CMake/airExistsConf.h

=== Testing/CMakeLists.txt ===
#
# Teem: Tools to process and visualize scientific data and images             .
# Copyright (C) 2013, 2012, 2011, 2010, 2009  University of Chicago
# Copyright (C) 2008, 2007, 2006, 2005  Gordon Kindlmann
# Copyright (C) 2004, 2003, 2002, 2001, 2000, 1999, 1998  University of Utah
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# (LGPL) as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The terms of redistributing and/or modifying this software also
# include exceptions to the LGPL that facilitate static linking.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

project(TEEMTesting)

# Create a header file with the path to the data in it.  Note that we don't
# have to make these paths "windows friendly" as it turns out windows can read
# forward slashed paths.
set(TESTING_DATA_PATH "${CMAKE_SOURCE_DIR}/data" CACHE PATH
  "Path to testing data")
mark_as_advanced(TESTING_DATA_PATH)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/testDataPath.h.in"
  "${CMAKE_BINARY_DIR}/include/testDataPath.h"
  )

# This just runs nrrdSanity as test called "nrrd.Sanity"
# We don't do the same for airSanity because that's an
# "experimental app" . . .
add_test(NAME nrrd.Sanity COMMAND $<TARGET_FILE:nrrdSanity>)

# Hope to eventually have tests in all directories; until then
# many of these are commented out. (TEEM_LIB_LIST)
add_subdirectory(air)
# add_subdirectory(hest)
add_subdirectory(biff)
add_subdirectory(nrrd)
# add_subdirectory(ell)
add_subdirectory(unrrdu)
# add_subdirectory(alan)
# add_subdirectory(moss)
# add_subdirectory(tijk)
add_subdirectory(gage)
# add_subdirectory(dye)
# add_subdirectory(bane)
# add_subdirectory(limn)
# add_subdirectory(echo)
# add_subdirectory(hoover)
# add_subdirectory(seek)
add_subdirectory(ten)
# add_subdirectory(elf)
# add_subdirectory(pull)
# add_subdirectory(coil)
# add_subdirectory(push)
# add_subdirectory(mite)
add_subdirectory(meet)

=== Examples/sanity/CMakeLists.txt ===
project (TeemSampleProject)

cmake_minimum_required(VERSION 2.8)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif()

find_package(Teem REQUIRED)
include(${Teem_USE_FILE})

add_executable(sample sanity.c)
target_link_libraries(sample teem)

=== Testing/air/CMakeLists.txt ===
#
# Teem: Tools to process and visualize scientific data and images             .
# Copyright (C) 2013, 2012, 2011, 2010, 2009  University of Chicago
# Copyright (C) 2008, 2007, 2006, 2005  Gordon Kindlmann
# Copyright (C) 2004, 2003, 2002, 2001, 2000, 1999, 1998  University of Utah
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# (LGPL) as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The terms of redistributing and/or modifying this software also
# include exceptions to the LGPL that facilitate static linking.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

add_executable(test_miscAir miscAir.c)
target_link_libraries(test_miscAir teem)
add_test(NAME misc COMMAND $<TARGET_FILE:test_miscAir>)

add_executable(test_mtrand mtrand.c)
target_link_libraries(test_mtrand teem)
add_test(NAME mtrand COMMAND $<TARGET_FILE:test_mtrand>)

add_executable(test_amath amath.c)
target_link_libraries(test_amath teem)
add_test(NAME amath COMMAND $<TARGET_FILE:test_amath>)

add_executable(test_string string.c)
target_link_libraries(test_string teem)
add_test(NAME string COMMAND $<TARGET_FILE:test_string>)

add_executable(test_strtok strtok.c)
target_link_libraries(test_strtok teem)
add_test(NAME strtok COMMAND $<TARGET_FILE:test_strtok>)

add_executable(test_pptest pptest.c)
target_link_libraries(test_pptest teem)
add_test(NAME pptest COMMAND $<TARGET_FILE:test_pptest>)

=== Testing/biff/CMakeLists.txt ===
#
# Teem: Tools to process and visualize scientific data and images             .
# Copyright (C) 2013, 2012, 2011, 2010, 2009  University of Chicago
# Copyright (C) 2008, 2007, 2006, 2005  Gordon Kindlmann
# Copyright (C) 2004, 2003, 2002, 2001, 2000, 1999, 1998  University of Utah
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# (LGPL) as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The terms of redistributing and/or modifying this software also
# include exceptions to the LGPL that facilitate static linking.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

add_executable(test_biff test.c)
target_link_libraries(test_biff teem)
add_test(NAME biff COMMAND $<TARGET_FILE:test_biff>)

=== Testing/gage/CMakeLists.txt ===
#
# Teem: Tools to process and visualize scientific data and images             .
# Copyright (C) 2013, 2012, 2011, 2010, 2009  University of Chicago
# Copyright (C) 2008, 2007, 2006, 2005  Gordon Kindlmann
# Copyright (C) 2004, 2003, 2002, 2001, 2000, 1999, 1998  University of Utah
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# (LGPL) as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The terms of redistributing and/or modifying this software also
# include exceptions to the LGPL that facilitate static linking.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

add_executable(test_sbp tsbp.c)
target_link_libraries(test_sbp teem)
add_test(NAME stackBlurParm COMMAND $<TARGET_FILE:test_sbp> -sbp 0-5-4.2)

add_executable(test_probeScl probeScl.c)
target_link_libraries(test_probeScl teem)
add_test(NAME probeScl COMMAND $<TARGET_FILE:test_probeScl>)

add_executable(test_probePolynomial probePolynomial.c)
target_link_libraries(test_probePolynomial teem)
add_test(NAME probePolynomial COMMAND $<TARGET_FILE:test_probePolynomial>)

add_executable(test_probeMulti probeMulti.c)
target_link_libraries(test_probeMulti teem)
add_test(NAME probeMulti COMMAND $<TARGET_FILE:test_probeMulti>)

=== Testing/meet/CMakeLists.txt ===
#
# Teem: Tools to process and visualize scientific data and images             .
# Copyright (C) 2013, 2012, 2011, 2010, 2009  University of Chicago
# Copyright (C) 2008, 2007, 2006, 2005  Gordon Kindlmann
# Copyright (C) 2004, 2003, 2002, 2001, 2000, 1999, 1998  University of Utah
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# (LGPL) as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The terms of redistributing and/or modifying this software also
# include exceptions to the LGPL that facilitate static linking.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

add_executable(test_enmall enmall.c)
target_link_libraries(test_enmall teem)
add_test(NAME enmall COMMAND $<TARGET_FILE:test_enmall>)

add_executable(test_kernall kernall.c)
target_link_libraries(test_kernall teem)
add_test(NAME kernall COMMAND $<TARGET_FILE:test_kernall>)

add_executable(test_buildinfo buildinfo.c)
target_link_libraries(test_buildinfo teem)
add_test(NAME buildinfo COMMAND $<TARGET_FILE:test_buildinfo>)

add_executable(test_probeSS probeSS.c)
target_link_libraries(test_probeSS teem)
add_test(NAME probeSS_box01 COMMAND $<TARGET_FILE:test_probeSS> -k box -supp 1.0 -pnum 1500)
add_test(NAME probeSS_cos01 COMMAND $<TARGET_FILE:test_probeSS> -k cos -supp 1.0 -pnum 1500)
add_test(NAME probeSS_cos02 COMMAND $<TARGET_FILE:test_probeSS> -k cos -supp 2.0 -pnum 1200)
add_test(NAME probeSS_cos04 COMMAND $<TARGET_FILE:test_probeSS> -k cos -supp 4.0 -pnum 1000)
add_test(NAME probeSS_cos10 COMMAND $<TARGET_FILE:test_probeSS> -k cos -supp 9.0 -pnum 800)
add_test(NAME probeSS_ctmr02 COMMAND $<TARGET_FILE:test_probeSS> -k ctmr -supp 2.0 -pnum 1300)
add_test(NAME probeSS_ctmr04 COMMAND $<TARGET_FILE:test_probeSS> -k ctmr -supp 4.0 -pnum 1300)
add_test(NAME probeSS_ctmr10 COMMAND $<TARGET_FILE:test_probeSS> -k ctmr -supp 9.0 -pnum 1300)

=== Testing/nrrd/CMakeLists.txt ===
#
# Teem: Tools to process and visualize scientific data and images             .
# Copyright (C) 2013, 2012, 2011, 2010, 2009  University of Chicago
# Copyright (C) 2008, 2007, 2006, 2005  Gordon Kindlmann
# Copyright (C) 2004, 2003, 2002, 2001, 2000, 1999, 1998  University of Utah
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# (LGPL) as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The terms of redistributing and/or modifying this software also
# include exceptions to the LGPL that facilitate static linking.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

add_executable(test_trand trand.c)
target_link_libraries(test_trand teem)
add_test(NAME trand COMMAND $<TARGET_FILE:test_trand>)

add_executable(test_tload tload.c)
target_link_libraries(test_tload teem)
add_test(NAME tload COMMAND $<TARGET_FILE:test_tload>)

add_executable(test_tskip tskip.c)
target_link_libraries(test_tskip teem)
# Note the different file names; tests are run in parallel
add_test(NAME tskip11p COMMAND $<TARGET_FILE:test_tskip> -s 101 102 103 -p 66 81     -o tsA.raw tsA.nhdr)
add_test(NAME tskip11n COMMAND $<TARGET_FILE:test_tskip> -s 101 102 103 -p 66 81 -ns -o tsB.raw tsB.nhdr)
add_test(NAME tskip01p COMMAND $<TARGET_FILE:test_tskip> -s 101 102 103 -p 0 99      -o tsC.raw tsC.nhdr)
add_test(NAME tskip01n COMMAND $<TARGET_FILE:test_tskip> -s 101 102 103 -p 0 99 -ns  -o tsD.raw tsD.nhdr)
add_test(NAME tskip10p COMMAND $<TARGET_FILE:test_tskip> -s 101 102 103 -p 77 0      -o tsE.raw tsE.nhdr)
add_test(NAME tskip10n COMMAND $<TARGET_FILE:test_tskip> -s 101 102 103 -p 77 0 -ns  -o tsF.raw tsF.nhdr)

add_executable(test_sanity sanity.c)
target_link_libraries(test_sanity teem)
add_test(NAME sanity COMMAND $<TARGET_FILE:test_sanity>)

add_executable(test_macros macros.c)
target_link_libraries(test_macros teem)
add_test(NAME macros COMMAND $<TARGET_FILE:test_macros>)

add_executable(test_bspec tbspec.c)
target_link_libraries(test_bspec teem)
add_test(NAME bspec COMMAND $<TARGET_FILE:test_bspec> -bs bleed wrap pad:42)

=== Testing/ten/CMakeLists.txt ===
#
# Teem: Tools to process and visualize scientific data and images             .
# Copyright (C) 2013, 2012, 2011, 2010, 2009  University of Chicago
# Copyright (C) 2008, 2007, 2006, 2005  Gordon Kindlmann
# Copyright (C) 2004, 2003, 2002, 2001, 2000, 1999, 1998  University of Utah
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# (LGPL) as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The terms of redistributing and/or modifying this software also
# include exceptions to the LGPL that facilitate static linking.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

add_executable(test_tendlist tendlist.c)
target_link_libraries(test_tendlist teem)
add_test(NAME tendlist COMMAND $<TARGET_FILE:test_tendlist>)

add_executable(test_glyphBqd glyphBqd.c)
target_link_libraries(test_glyphBqd teem)
add_test(NAME glyphBqd COMMAND $<TARGET_FILE:test_glyphBqd>)

=== Testing/unrrdu/CMakeLists.txt ===
#
# Teem: Tools to process and visualize scientific data and images             .
# Copyright (C) 2013, 2012, 2011, 2010, 2009  University of Chicago
# Copyright (C) 2008, 2007, 2006, 2005  Gordon Kindlmann
# Copyright (C) 2004, 2003, 2002, 2001, 2000, 1999, 1998  University of Utah
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# (LGPL) as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The terms of redistributing and/or modifying this software also
# include exceptions to the LGPL that facilitate static linking.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

add_executable(test_unulist unulist.c)
target_link_libraries(test_unulist teem)
add_test(NAME unulist COMMAND $<TARGET_FILE:test_unulist>)

=== src/bin/CMakeLists.txt ===
#
# Teem: Tools to process and visualize scientific data and images             .
# Copyright (C) 2013, 2012, 2011, 2010, 2009  University of Chicago
# Copyright (C) 2008, 2007, 2006, 2005  Gordon Kindlmann
# Copyright (C) 2004, 2003, 2002, 2001, 2000, 1999, 1998  University of Utah
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# (LGPL) as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The terms of redistributing and/or modifying this software also
# include exceptions to the LGPL that facilitate static linking.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

macro(CREATE_EXEC name sources)
  add_executable(${name} ${sources})
  target_link_libraries(${name} teem)
  install(TARGETS ${name}
    RUNTIME DESTINATION bin
    COMPONENT Runtime
    )
  set_target_properties(${name} PROPERTIES
    INSTALL_RPATH ${CMAKE_INSTALL_PREFIX}/lib
    )
endmacro()

# These binaries should not be depending on BUILD_EXPERIMENTAL_LIBS
CREATE_EXEC(nrrdSanity nrrdSanity.c)
CREATE_EXEC(overrgb overrgb.c)
CREATE_EXEC(ilk ilk.c)
CREATE_EXEC(mrender mrender.c)
CREATE_EXEC(miter miter.c)
CREATE_EXEC(vprobe vprobe.c)
CREATE_EXEC(gprobe gprobe.c)
CREATE_EXEC(unu unu.c)
CREATE_EXEC(puller puller.c)
CREATE_EXEC(tend tend.c)

# NOTE: The BUILD_EXPERIMENTAL_LIBS-dependent inclusion of binaries has to be
# done with knowledge of how BUILD_EXPERIMENTAL_LIBS behaves in the top-level
# CMakeLists.txt file
if(BUILD_EXPERIMENTAL_APPS)
  CREATE_EXEC(airSanity airSanity.c)
  CREATE_EXEC(cubic cubic.c)
  CREATE_EXEC(qbert qbert.c)
  CREATE_EXEC(emap emap.c)
  CREATE_EXEC(talkweb talkweb.c)
  CREATE_EXEC(pprobe pprobe.c)
  CREATE_EXEC(ninspect ninspect.c)
  CREATE_EXEC(ungantry ungantry.c)
  CREATE_EXEC(deconv deconv.c)
  if(BUILD_EXPERIMENTAL_LIBS)
    CREATE_EXEC(gkms gkms.c)
    CREATE_EXEC(spots spots.c)
  endif()
endif()

=== src/hex/CMakeLists.txt ===
#
# Teem: Tools to process and visualize scientific data and images
# Copyright (C) 2013, 2012, 2011, 2010, 2009  University of Chicago
# Copyright (C) 2008, 2007, 2006, 2005  Gordon Kindlmann
# Copyright (C) 2004, 2003, 2002, 2001, 2000, 1999, 1998  University of Utah
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# (LGPL) as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The terms of redistributing and/or modifying this software also
# include exceptions to the LGPL that facilitate static linking.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

add_executable(dehex
 dehex.c
)
add_executable(enhex
  enhex.c
)

=== debian/changelog ===
teem (1.12.0~20160122-8) unstable; urgency=medium

  * debian/rules: Remove hard-coded -DCMAKE_BUILD_TYPE
  * debian/rules: Cleanup build flags
  * debian/control: Bump Standards-Version to 4.7.2 (no changes needed)

 -- Dominique Belhachemi <domibel@debian.org>  Sat, 06 Sep 2025 02:10:05 -0400

teem (1.12.0~20160122-7) unstable; urgency=medium

  * Set minimum cmake to 3.10 (Closes: 1113565)

 -- Dominique Belhachemi <domibel@debian.org>  Wed, 03 Sep 2025 20:52:05 -0400

teem (1.12.0~20160122-6) unstable; urgency=medium

  * Team upload.
  [ wuruilong <wuruilong@loongson.cn> ]
  * Add support for loong64 Closes: #1068627

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 29 Dec 2024 14:52:59 +0100

teem (1.12.0~20160122-5) unstable; urgency=medium

  * Team upload.

  [ Bo YU ]
  * d/rules: set DEB_CFLAGS_MAINT_APPEND = -ffp-contract=off in riscv64
    (Closes: #1011263)

  [ Boyuan Yang ]
  * debian/control: Bump Standards-Version to 4.6.1.
  * d/rules: Disable parallel test to circumvent potential random FTBFS.

 -- Boyuan Yang <byang@debian.org>  Wed, 22 Jun 2022 20:57:47 -0400

teem (1.12.0~20160122-4) unstable; urgency=medium

  * Team upload.
  * Fix team name according to Debian Science team policy
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Do not parse d/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Refer to specific version of license GPL-2+.
  * watch file standard 4 (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 23 Nov 2020 17:28:27 +0100

teem (1.12.0~20160122-3) unstable; urgency=medium

  * Team upload.
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Thu, 06 Sep 2018 16:54:31 +0200

teem (1.12.0~20160122-2) unstable; urgency=medium

  * Team upload.
  * Re-apply change from Tobias' NMU 1.11.0~svn6057-1.1 there were accidentally
    reverted by the previous upload.  Closes: #820503, #704206
  * Add arm64 and ppc64el to -ffp-contract=off list to fix FTBFS on those
    architectures.  Closes: #820772
  * Fix Vcs-Git URL.
  * Bump debhelper compat level to 10.
    + --parallel is now the default.
  * Bump Standards-Version to 3.9.8, no changes needed.
  * Enable harening (bindnow).

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 02 Apr 2017 21:50:23 +0200

teem (1.12.0~20160122-1) unstable; urgency=medium

  * Team upload
  * New SVN snapshot
  * Rework d/get-orig-source to create data based version numbers
  * Packaging moved from SVN to Git
  * cme fix dpkg-control
  * debhelper 9
  * cme fix dpkg-copyright
  * Drop -dbg package which is created automatically
  * Do not explicitly depend from quilt
  * Update and split up quilt patches and add DEP3 headers
  * DEP5 fix
  * Replace cdbs by dh (try d-shlibs but failed since there is no static
    library)

 -- Andreas Tille <tille@debian.org>  Thu, 14 Apr 2016 15:56:57 +0200

=== debian/control ===
Source: teem
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dominique Belhachemi <domibel@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               zlib1g-dev,
               libpng-dev,
               libbz2-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/teem
Vcs-Git: https://salsa.debian.org/science-team/teem.git
Homepage: http://teem.sourceforge.net/
Rules-Requires-Root: no

Package: libteem-dev
Architecture: any
Section: libdevel
Depends: libteem2 (= ${binary:Version}),
         ${misc:Depends}
Conflicts: libteem1-dev
Provides: libteem1-dev
Replaces: libteem1-dev
Description: Tools to process and visualize scientific data and images - development
 Teem is a coordinated group of libraries for representing, processing, and
 visualizing scientific raster data. Teem includes command-line tools that
 permit the library functions to be quickly applied to files and streams,
 without having to write any code. The most important and useful libraries in
 Teem are:
 .
  * Nrrd (and the unu command-line tool on top of it) supports a range of
    operations for transforming N-dimensional raster data (resample, crop,
    slice, project, histogram, etc.), as  well as the NRRD file format for
    storing arrays and their meta-information.
  * Gage: fast convolution-based measurements at arbitrary point locations in
    volume datasets (scalar, vector, tensor, etc.)
  * Mite: a multi-threaded ray-casting volume render with transfer functions
    based on any quantity Gage can measure
  * Ten: for estimating, processing, and visualizing diffusion tensor fields,
    including fiber tractography methods.
 .
 This package provides the Teem header files required to compile C++ programs
 that use Teem to do 3D visualisation.

Package: teem-apps
Architecture: any
Depends: libteem2 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Tools to process and visualize scientific data and images - command line tools
 Teem is a coordinated group of libraries for representing, processing, and
 visualizing scientific raster data. Teem includes command-line tools that
 permit the library functions to be quickly applied to files and streams,
 without having to write any code. The most important and useful libraries in
 Teem are:
 .
  * Nrrd (and the unu command-line tool on top of it) supports a range of
    operations for transforming N-dimensional raster data (resample, crop,
    slice, project, histogram, etc.), as  well as the NRRD file format for
    storing arrays and their meta-information.
  * Gage: fast convolution-based measurements at arbitrary point locations in
    volume datasets (scalar, vector, tensor, etc.)
  * Mite: a multi-threaded ray-casting volume render with transfer functions
    based on any quantity Gage can measure
  * Ten: for estimating, processing, and visualizing diffusion tensor fields,
    including fiber tractography methods.
 .
 This package contains some simple command-line tools which provide fast and
 easy access to the functionality in the various libraries.

Package: libteem2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Tools to process and visualize scientific data and images - runtime
 Teem is a coordinated group of libraries for representing, processing, and
 visualizing scientific raster data. Teem includes command-line tools that
 permit the library functions to be quickly applied to files and streams,
 without having to write any code. The most important and useful libraries in
 Teem are:
 .
  * Nrrd (and the unu command-line tool on top of it) supports a range of
    operations for  transforming N-dimensional raster data (resample, crop,
    slice, project, histogram, etc.), as  well as the NRRD file format for
    storing arrays and their meta-information.
  * Gage: fast convolution-based measurements at arbitrary point locations in
    volume datasets (scalar, vector, tensor, etc.)
  * Mite: a multi-threaded ray-casting volume render with transfer functions
    based on any quantity Gage can measure
  * Ten: for estimating, processing, and visualizing diffusion tensor fields,
    including fiber tractography methods.
 .
 This package provides the runtime files required to run programs
 that use Teem to do 3D visualisation.

=== debian/rules ===
#!/usr/bin/make -f

# Set this value to 0/1 to turn off/on verbose mode.
#export DH_VERBOSE=1

ABI_VERSION := 2

include /usr/share/dpkg/default.mk
UVERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/~[0-9]\+$$//' )
BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)

CMAKE_EXTRA_FLAGS = \
        -DCMAKE_SKIP_RPATH:BOOL=ON \
        -DBUILD_SHARED_LIBS:BOOL=ON \
        -DBUILD_EXPERIMENTAL_APPS:BOOL=OFF \
        -DBUILD_EXPERIMENTAL_LIBS:BOOL=OFF \
        -DBUILD_TESTING:BOOL=ON \
        -DTeem_USE_LIB_INSTALL_SUBDIR:BOOL=ON

ifneq (,$(filter $(DEB_HOST_ARCH_CPU), i386))
  export DEB_CFLAGS_MAINT_APPEND = -ffloat-store
endif
ifneq (,$(filter $(DEB_HOST_ARCH_CPU), arm64 loong64 powerpc ppc64 ppc64el riscv64 s390x))
  export DEB_CFLAGS_MAINT_APPEND = -ffp-contract=off
endif


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --no-parallel -- LD_LIBRARY_PATH="$(CURDIR)/$(BUILDDIR)/bin:$$LD_LIBRARY_PATH"
endif

override_dh_install:
	dh_install
	dh_install -plibteem${ABI_VERSION}    debian/tmp/usr/lib/Teem-$(UVERSION)/*so.*         usr/lib
	dh_install -plibteem-dev              debian/tmp/usr/lib/Teem-$(UVERSION)/*.so          usr/lib
	dh_install -plibteem-dev              debian/tmp/usr/lib/Teem-$(UVERSION)/*.cmake       usr/lib/Teem-$(UVERSION)
	dh_install -plibteem-dev              debian/tmp/usr/include/teem/*                usr/include/teem

override_dh_install_d-shlibs: # This does only work for packages with static lib
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --movedev "debian/tmp/usr/include/$(DEB_SOURCE)		usr/include \
		    --movedev "debian/tmp/usr/lib/Teem-$(UVERSION)/*.cmake	usr/lib/Teem-$(UVERSION) \
		      debian/tmp/usr/lib/*/lib$(DEB_SOURCE).so


get-orig-source:
	/bin/sh $(CURDIR)/debian/get-orig-source

=== debian/watch ===
version=4
opts="dversionmangle=s/\.dfsg1//" http://sf.net/teem/teem-(.*)-src\.tar\.gz
